#!/bin/sh

IFACE=fxp0
FLOW_COLLECTOR=127.0.0.1
FLOW_PORT=1001
INACTIVE_TIMEOUT=15
ACTIVE_TIMEOUT=60
WORKDIR=/usr/local/netflow

NGCTL=/usr/sbin/ngctl
SAMPLICATE=/usr/local/bin/samplicate
CAPTURE=/usr/local/bin/flow-capture
KILLALL=/usr/bin/killall

case "$1" in
	start)
		${NGCTL} -f- <<-SEQ1
			mkpeer ${IFACE}: netflow lower iface0
			name ${IFACE}:lower netflow
			connect ${IFACE}: netflow: upper out0
			msg netflow: settimeouts { inactive = ${INACTIVE_TIMEOUT} active = ${ACTIVE_TIMEOUT} }
			mkpeer netflow: ksocket export inet/dgram/udp
			msg netflow:export connect inet/${FLOW_COLLECTOR}:${FLOW_PORT}
		SEQ1

		${SAMPLICATE} -s 127.0.0.1 -p 1001 -f 127.0.0.1/1002 81.30.199.70/2002
		${CAPTURE} -e 6000 -V 5 -w ${WORKDIR} -z 9 -N 0 -p - 127.0.0.1/127.0.0.1/1002
	;;
	stop)
		${NGCTL} shutdown netflow:
		${NGCTL} shutdown ${IFACE}:
		${KILLALL} samplicate
		${KILLALL} flow-capture
	;;
	*)
		echo "usage: ${0##/*} <start|stop>"
	;;
esac
