#!/bin/sh

LANG=C; export LANG
LC_ALL=C ; export LC_ALL
PATH=$path:/bin:/usr/bin:/usr/local/bin ; export PATH

find=/usr/bin/find
mpd=/usr/local/sbin/mpd4
fw='/sbin/ipfw -q'

logdir=/var/log
rundir=/var/run/mpd
failcount=0
logfile=$logdir/mpd.start

while : ; do
        echo "Startup: `date`" >> $logfile
	$fw table 1 flush
	$fw table 2 flush
	[ ! -d $rundir ] && mkdir -p $rundir
        find $rundir/ -type f -delete >/dev/null 2>&1
        start=`date '+%s'`
        $mpd -p /var/run/mpd.pid >/dev/null 2>&1
        echo "Shutdown: `date`" >> $logfile
        stop=`date '+%s'`
        t=$(($stop - $start))
        if [ $t -ge 0 -a $t -lt 20 ] ; then
                failcount=$(($failcount + 1))
        else
                failcount=0
        fi
        if [ $failcount -gt 5 ] ; then
              echo "runmpd.sh: EXITING DUE TO REPEATED, FREQUENT FAILURES" >> $logfile
                exit 1
        fi
done
